Machine developement (MD) time and beam time at the CERN Control Centre (CCC) is limited. Consequently, there is not always time to fully test and implement different numerical optimisation algorithms that often require tens or hundreds of iterations to converge. This also applies to testing different algorithms of the optimisation environment for the MKP injection kicker delays of the Super Proton Synchrotron (SPS) injection system, described in [this GitLab repository](https://gitlab.cern.ch/elwaagaa/mkp_delay_optimiser). There are eight individual delays for the kicker magnets, and one general delay. These delays, which are in nanoseconds, determine how much deflection is given to the injected beam but also how perturbed the circulating beam will be. This repository contains files and scripts to train, validate and test a surrogate model of MKP delays, using neural networks on the existing data from the runs with the optimisation environment. 

In order to compare different optimisation algorithms, we create a simple *neural network* (NN) to create a computationally inexpensive surrogate model and approximate the behaviour of the beam position for different MKP kicker delays, based upon the recorded data. For every neuron $`k`$ in the network, there is a state of activation $`a_k`$, which equivalent to the output of the neuron and determines whether a neuron is active or not. Some input vector $`\vec x`$, normalised between $`[0, 1]`$, constitute the input layer activations $`\boldsymbol a^{(0)}`$, and the output vector $`\vec y`$ contains the output layer activations $`\boldsymbol a^{(l)}`$. In our case, the input $`\vec x`$ corresponds to the nine MKP delays in nanoseconds and the output $`\vec y = y`$ to the loss function (squared sum of the injection oscillation amplitude of the beam in the SPS).  

The connections between the neurons are defined by weight elements $`w_{jk}`$ that determines the effect which the signal of neuron has on a neuron in the next layer.  $`w^{(l)}_{jk}`$ denotes the weight for the connection from the $`k^{\textrm{th}}`$ neuron in the $`(l-1)^{\textrm{th}}`$ layer to the $`j^{\textrm{th}}`$ neuron in the $`l^{\textrm{th}}`$  layer.  There is also a bias (external input, or offset) $`b_j^{(l)}`$ of the $`j^{\textrm{th}}`$ neutron in the $`l^{\textrm{th}}`$ layer. Thus, $`a_j^{(l)}`$ is the activation of the $`j^{\textrm{th}}`$ neutron in the $`l^{\textrm{th}}`$ layer. An activation function $`f^{(l)}`$ determines the new level of activation based on the weighted sum of the activations in the previous layer   

```math
\boldsymbol a^{(l)} = f ^{(l)} \Big( W^{(1)} \boldsymbol a^{(l-1)} + \boldsymbol b^{(l)} \Big)   
```

The activation function $`f`$ transforms the weighted sum of the input into output from the neurons in one layer of the network. $`f`$ can both be linear and non-linear. More details and background on neural networks and activation functions can be found in my [CERN Master's Thesis on CDS](https://cds.cern.ch/record/2813209), where the detailed architecture of the neural network is also described. 


![neural_networks.png](./neural_networks.png)

We want to find weights and biases such that the output $`\vec y_{\textrm{model}}`$ from the network model approximates the real output $`\vec y_{\textrm{real}}`$ from the accelerator for all training inputs $`\vec x`$. We quantify how well the model approximates real data by defining the mean squared error (MSE) cost function $`C`$

```math
C(w, b) = \frac{1}{2n} \sum_x ||y(x) - \boldsymbol a^{(l)}||^2 
```

where $`w`$ denotes all the weights in the network, $`b`$ all the biases, $`n`$ is the total number of training inputs, and $`\boldsymbol a = \vec y_{\textrm{model}}`$ is the output vector from the model for the given input $`x`$. The cost function $`C(w, b)`$ becomes small when the final output $`\boldsymbol a`$ of the model approximates $`y(x)`$ well, where the quadratic difference heavy penalises any offset. To find weights and biases for the model that minimises $`C`$, we use an algorithm known as *stochastic gradient descent*, an iterative optimisation algorithm to find a local minimum estimating the gradient $`\nabla C = (\partial C/\partial w, \partial C/\partial b)`$ (where $`w`$ and $`b`$ denote all the weights and biases) of the cost function using randomly selected subsets of the data. In order to find the weights and biases minimising the cost function, we use a method called  *backpropagation*. Instead of computing the gradient directly with respect to all the weights, backpropagation instead computes the gradient of the cost function with respect to each weight by the chain rule, calculating the gradient one layer at a time from backwards iteration.

To train the model, we divide the recorded data set into 70% training data, 20% validation data and 10% test data. We use the `pytorch` library to create the neural network and to train it. The training, validation and testing - along with the class representing the neural network - are contained in `train_neural_network_with_validation.py`. The script `dataset_and_optimisation_plot_generator.py` extracts the pickled output data from the runs of the optimisation environment to generate the dataset for the neural network. `load_neural_network.py` is a wrapper to load already trained models, and test them. 

Training is performed during a chosen number of iterations, called *epochs*, in which the algorithm scans through the whole data set. However, we allow the model to update the weights before having scanned through the whole data set. After each epoch, the updated model is tested against the cost function $`C`$ with the yet unseen validation data set to tune the parameters of the networks. We stop the training when the loss function for the validation flattens and the training losses keep on decreasing, which means that the learning algorithm overfits the model parameters for the training dataset. The training and validation loss curves are displayed below to the left. We stop the training process at 200 epochs (green dashed line), after which the learning process starts overfitting. As a last step, we test the model with a final unbiased evaluation against unseen test data, and make a regression plot of predicted values $`y_{\textrm{predicted}}`$ versus the actual test set values $`y_{\textrm{actual}}`$, displayed to the right below. 

![nn_200_epochs_norm_input_output_training_validating_testing.PNG](./nn_200_epochs_norm_input_output_training_validating_testing.PNG)

Once the neural network model of the accelerator has been trained, validated and tested, we want to implement other optimisation algorithms on the model to compare performances. The script `nn_optimisation_IC_sweeper.py` generates initial conditions from a normal distribution and tests different optimisation algorithms with the trained model, showing performance plots (cumulative distributions over the loss function) for the different algorithms, allowing us to compare well the different optimisation algorithms scored. The script `nn_optimisation_IC_data_profile_generator.py` generates data profiles from the performance plots, which are plots that show the fraction of "successful" runs for a given tolerance $`\alpha`$, individual for each optimisation algorithm. This allows us to invidually compare how much the different optimisation algorithms improve if we increase the maximum number of allowed function evaluations. 
